      program multipx5
c program to multiplex the microtremor data observed independently
c & simultaneously.
c
c				                Apr,13,2010 T. Yokoi, IISEE, BRI
      parameter(nmax=66000,nch0=12)
      character cline(3)*80,cdum*13,filen*80,cfn(nch0)*20,
     *          cdummy*8,cout*12,cattach*50,cform1*15,cform2*15,
     *		comment*50,cchar*10
c     character cdrv*3,cwkf*11
c     character cdrv*2,cwkf*2
      character cdrv*2,cwkf*9
      real*4 x(nmax,nch0)
      data cchar/'0123456789'/
c root folder name
c     data cdrv/'../'/ 
      data cdrv/'./'/ 
c working folder name
      cwkf=cdrv//'ccawkf/'
c      cwkf=cdrv
      filen=cdrv//'multipx5.prm'
      open(10,file=filen,status='old')
      write(6,*)' Working Folder=',cwkf
c channel number
      read(10,*)nch,dt
      write(6,*)' Nch=',nch,' dt=',dt
c start and end time 
      read(10,*)tst,tdur
      nst0=int(tst/dt)+1
      ndur0=int(tdur/dt)
c scale factor fixed for all measurement
      read(10,*)scale
      write(6,*)' Scale Factor=',scale
c number of letters, character string automatically attched to the input file name
      read(10,*)nattach,cattach
c output file name
      read(10,*)n_out,cout
c comment
      read(10,'(a50)')comment
      write(6,*)comment
c number of measurement in the same array configuration
      read(10,*)n_mea,ncfrm
c      
      call formatter(nch,cform1,cform2)
c
      do i_mea=1,n_mea
       write(6,*)i_mea,'-th measurement:',nch
c input file names
       read(10,*)(cfn(ich),ich=1,nch)
       write(6,'(7(a8,1x))')(cfn(ich),ich=1,nch)
       ndat=ndur0
       do j=1,nch
        filen=cwkf//cfn(j)(1:ncfrm)//cattach(1:nattach)
        open(1,file=filen,status='old')
        do i=1,3
         read(1,'(a80)')cline(i)
        enddo
        do i=1,nst0-1
         read(1,*)cdummy
        enddo
        do i=1,ndur0
c read input data
         read(1,*,end=10)cdummy,cdum,xdum
c         read(1,*,end=10)cdum,xdum
	   x(i,j)=xdum/scale
        enddo
   10   ndur0=i-1
        write(6,*)ndur0
        close(1)
       enddo
c
       i_mea1=mod(i_mea,10)
       if(i_mea.lt.10) then
        filen=cwkf//cout(1:n_out)//'0'//cchar(i_mea1+1:i_mea1+1)//'.dat'
       else if(i_mea.lt.100) then
	  i_mea2=mod(i_mea/10,10)
        filen=cwkf//cout(1:n_out)//cchar(i_mea2+1:i_mea2+1)
     *                           //cchar(i_mea1+1:i_mea1+1)//'.dat'
       else
        write(6,*) 'measurement number > 99.'
       endif
       write(6,*)filen
       open(2,file=filen,status='unknown')
       write(2,'(i8,f8.4,e16.4,i8)')nch,dt,scale,ndur0
       write(2,'(a50)')comment
       do i=1,ndur0
        write(2,cform2)real(i-1)*dt,(x(i,j),j=1,nch)
       enddo
      enddo
      close(10)
c
      stop
      end
c+++++
      subroutine formatter(nch,cform1,cform2)
      character cform1*15,cform2*15
      if(nch.ge.10) then
       write(cform1,'(a4,i2,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,i2,a6)')'(f12.6,',nch,'e15.7)'
      else if(nch.ge.3) then
       write(cform1,'(a4,1x,i1,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a7,1x,i1,a6)')'(f12.6,',nch,'e15.7)'
      else
       write(6,*)'nch should be bigger than 2!'
      endif
      end
